/* Copyright (c) 2000-2006 ActiveState Software Inc.
   See the file LICENSE.txt for licensing information. */

//---- globals
var _findingInterps = false;
var prefExecutable = null;

//---- functions

function OnPreferencePageOK(prefset)
{
    var ok = true;

    // ensure that the default ruby interpreter is valid
    var defaultInterp = prefset.getStringPref("rubyDefaultInterpreter");
    if (defaultInterp != "") {
        var koSysUtils = Components.classes["@activestate.com/koSysUtils;1"].
            getService(Components.interfaces.koISysUtils);
        if (! koSysUtils.IsFile(defaultInterp)) {
            alert("No Ruby interpreter could be found at '" +
                  defaultInterp + "'. You must make another selection " +
                  "for the default Ruby interpreter.\n");
            ok = false;
            document.getElementById("rubyDefaultInterpreter").focus();
        }
    }

    return ok;
}

// Populate the (tree) list of available Ruby interpreters on the current
// system.
function PrefRuby_PopulateRubyInterps()
{
    var availInterpList = document.getElementById("rubyDefaultInterpreter");
    var infoSvc = Components.classes["@activestate.com/koInfoService;1"].
                      getService(Components.interfaces.koIInfoService);

    // remove any existing items and add a "finding..." one
    _findingInterps = true;
    availInterpList.removeAllItems();
    availInterpList.appendItem("Finding available Ruby interpreters...");

    // get a list of installed Ruby interpreters
    var sysUtils = Components.classes['@activestate.com/koSysUtils;1'].
        getService(Components.interfaces.koISysUtils);
    var availInterps = new Array();
    availInterps = sysUtils.WhichAll("ruby", new Object());

    availInterpList.removeAllItems();
    availInterpList.appendItem("Find on Path",'');

    var found = false;
    // populate the tree listing them
    if (availInterps.length == 0) {
        // tell the user no interpreter was found and direct them to
        // ActiveState to get one
        document.getElementById("no-avail-interps-message").removeAttribute("collapsed");
    } else {
        for (var i = 0; i < availInterps.length; i++) {
            availInterpList.appendItem(availInterps[i],availInterps[i]);
            if (availInterps[i] == prefExecutable) found = true;
        }
    }
    if (!found && prefExecutable)
        availInterpList.appendItem(prefExecutable,prefExecutable);
    _findingInterps = false;
}


function PrefRuby_OnLoad()
{
    if (parent.hPrefWindow.prefset.hasStringPref('rubyDefaultInterpreter') &&
        parent.hPrefWindow.prefset.getStringPref('rubyDefaultInterpreter'))
        prefExecutable = parent.hPrefWindow.prefset.getStringPref('rubyDefaultInterpreter');
    else
        prefExecutable = '';
    PrefRuby_PopulateRubyInterps();

    var origWindow = windowManager_getMainWindow();
    var cwd = origWindow.View_GetCwd();
    parent.hPrefWindow.onpageload();
    var extraPaths = document.getElementById("rubyExtraPaths");
    extraPaths.setCwd(cwd)
    extraPaths.init() // must happen after onpageload
}

function loadRubyExecutable()
{
    var rubyExe = filepicker_openExeFile();
    if (rubyExe != null) {
        var availInterpList = document.getElementById("rubyDefaultInterpreter");
        availInterpList.selectedItem = availInterpList.appendItem(rubyExe, rubyExe);
    }
}

function loadRubyLogpath()
{
    var rubyLog = filepicker_getFolder();
    if (rubyLog != null) {
        var textbox = document.getElementById("ruby_debuggerlogpath");
        textbox.value = rubyLog;
    }
}


